.386

.MODEL flat,stdcall

OPTION CASEMAP:NONE

.const
	
	_WIN32_WINNT equ 300h

Include windows.inc
Include user32.inc
Include kernel32.inc

include httpext.inc

IncludeLib user32.lib
IncludeLib kernel32.lib




.DATA

	szAppName			db "ISAPI Extension 1",0

.data?

	
.code

DllEntry proc hInstance:DWORD, reason:DWORD, reserved1:DWORD
	
		
	mov  eax,TRUE
	ret
DllEntry Endp

GetExtensionVersion proc public pHVI:ptr HSE_VERSION_INFO
	
	; IIS calls this function first (after a quick call to DllEntry).
	; Return the version number and a description of the app.
	
	mov ecx,pHVI	
	
	mov [ecx].HSE_VERSION_INFO.dwExtensionVersion, 4d
	
	invoke lstrcpy, addr [ecx].HSE_VERSION_INFO.lpszExtensionDesc,addr szAppName 	
	
	mov eax,TRUE
	ret

GetExtensionVersion endp

HttpExtensionProc proc public uses esi edi pECB:ptr EXTENSION_CONTROL_BLOCK
	
	local bytes:DWORD

	; The true entry point for IIS to communicate with the DLL.
	; This is where all the work must happens.
	; For now I just want to see the name of the app returned in the browser.
	
	invoke lstrlen,addr szAppName
	mov bytes,eax
	
	mov ecx,pECB
	
	mov esi,[ecx].EXTENSION_CONTROL_BLOCK.ConnID

	invoke [ecx].EXTENSION_CONTROL_BLOCK.WriteClient,esi,addr szAppName,addr bytes,HSE_IO_SYNC  
	
	mov eax, TRUE
	Ret
HttpExtensionProc EndP

TerminateExtension proc public dwFlags:DWORD
	
	; Cleanup here.
	
	xor eax, eax
	Ret
TerminateExtension EndP


End DllEntry
